<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NoteStructure StructType
 * Meta informations extracted from the WSDL
 * - documentation: DataType for a NOTICe.
 * @subpackage Structs
 */
class NoteStructure extends AbstractStructBase
{
    /**
     * The SituationRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: SituationRef
     * @var \StructType\SituationRefStructure
     */
    public $SituationRef;
    /**
     * The SituationSimpleRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: SituationSimpleRef
     * @var \StructType\SituationSimpleRefStructure
     */
    public $SituationSimpleRef;
    /**
     * The SituationFullRef
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: SituationFullRef
     * @var \StructType\SituationFullRefStructure
     */
    public $SituationFullRef;
    /**
     * The Note
     * Meta informations extracted from the WSDL
     * - documentation: Text annotation that applies to an element.
     * - minOccurs: 0
     * @var \StructType\NaturalLanguageStringStructure
     */
    public $Note;
    /**
     * Constructor method for NoteStructure
     * @uses NoteStructure::setSituationRef()
     * @uses NoteStructure::setSituationSimpleRef()
     * @uses NoteStructure::setSituationFullRef()
     * @uses NoteStructure::setNote()
     * @param \StructType\SituationRefStructure $situationRef
     * @param \StructType\SituationSimpleRefStructure $situationSimpleRef
     * @param \StructType\SituationFullRefStructure $situationFullRef
     * @param \StructType\NaturalLanguageStringStructure $note
     */
    public function __construct(\StructType\SituationRefStructure $situationRef = null, \StructType\SituationSimpleRefStructure $situationSimpleRef = null, \StructType\SituationFullRefStructure $situationFullRef = null, \StructType\NaturalLanguageStringStructure $note = null)
    {
        $this
            ->setSituationRef($situationRef)
            ->setSituationSimpleRef($situationSimpleRef)
            ->setSituationFullRef($situationFullRef)
            ->setNote($note);
    }
    /**
     * Get SituationRef value
     * @return \StructType\SituationRefStructure|null
     */
    public function getSituationRef()
    {
        return $this->SituationRef;
    }
    /**
     * Set SituationRef value
     * @param \StructType\SituationRefStructure $situationRef
     * @return \StructType\NoteStructure
     */
    public function setSituationRef(\StructType\SituationRefStructure $situationRef = null)
    {
        $this->SituationRef = $situationRef;
        return $this;
    }
    /**
     * Get SituationSimpleRef value
     * @return \StructType\SituationSimpleRefStructure|null
     */
    public function getSituationSimpleRef()
    {
        return $this->SituationSimpleRef;
    }
    /**
     * Set SituationSimpleRef value
     * @param \StructType\SituationSimpleRefStructure $situationSimpleRef
     * @return \StructType\NoteStructure
     */
    public function setSituationSimpleRef(\StructType\SituationSimpleRefStructure $situationSimpleRef = null)
    {
        $this->SituationSimpleRef = $situationSimpleRef;
        return $this;
    }
    /**
     * Get SituationFullRef value
     * @return \StructType\SituationFullRefStructure|null
     */
    public function getSituationFullRef()
    {
        return $this->SituationFullRef;
    }
    /**
     * Set SituationFullRef value
     * @param \StructType\SituationFullRefStructure $situationFullRef
     * @return \StructType\NoteStructure
     */
    public function setSituationFullRef(\StructType\SituationFullRefStructure $situationFullRef = null)
    {
        $this->SituationFullRef = $situationFullRef;
        return $this;
    }
    /**
     * Get Note value
     * @return \StructType\NaturalLanguageStringStructure|null
     */
    public function getNote()
    {
        return $this->Note;
    }
    /**
     * Set Note value
     * @param \StructType\NaturalLanguageStringStructure $note
     * @return \StructType\NoteStructure
     */
    public function setNote(\StructType\NaturalLanguageStringStructure $note = null)
    {
        $this->Note = $note;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NoteStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
